// ASCIIReader.h: interface for the ASCIIReader class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ASCIIREADER_H
#define ASCIIREADER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif //SWIG


#include "DMFirstHeader.h"
#include <string>
#include <fstream>
#include "DigitalMaterial.h"
#include "DMReader.h"

class ASCIIReader: public DMReader
{
public:
	ASCIIReader(const std::string &filename = "data.txt");
	virtual ~ASCIIReader();
	void Open();
	void Close();
	std::string GetType(const std::string &name="root"); 
	bool Fill(Serializable *toFill, const std::string &name="root");
	Serializable *Get(const std::string &name="root");
	bool GetBool( const std::string& name );
	int GetInt(const std::string &name);
	double GetDouble(const std::string &name);
	std::string GetString(const std::string &name);
	int *GetIntArray(std::vector<int> &dims, const std::string &name);
	double *GetDoubleArray(std::vector<int> &dims, const std::string &name);
private:
	void Done();
	std::string offset;
	const int SIZE;
	char *buffer;
	std::ifstream in;
};

#endif // ASCIIREADER_H
