// BinaryReader.h: interface for the BinaryReader class.
//
//////////////////////////////////////////////////////////////////////

#ifndef BINARYREADER_H
#define BINARYREADER_H

#include "DigitalMaterial.h"

#include "DMReader.h"

class BinaryReader : public DMReader  
{
public:
    BinaryReader(const char *buffer = 0);
    virtual ~BinaryReader();
    //! Not used
    void Open() {}
    //! Not used
    void Close() {}
    std::string GetType(const std::string &name="root") ; 
    virtual bool Fill(Serializable *toFill, const std::string &name="root");
    virtual Serializable *Get(const std::string &name="root") ;
    virtual bool GetBool( const std::string& name ) ;
    virtual int GetInt(const std::string &name) ;
    virtual double GetDouble(const std::string &name) ;
    virtual std::string GetString(const std::string &name);
    virtual int *GetIntArray(std::vector<int> &dims, const std::string &name);
    virtual double *GetDoubleArray(std::vector<int> &dims, const std::string &name);

    template <class Type> 
        void GetArray(std::vector<int> &dims, const std::string &name, Type *&ip)
    { throw DMException("DMReader", "GetArray<>", "This type not implemented yet");}
    void GetArray(std::vector<int> &dims, const std::string &name, int *&ip)
                { ip = GetIntArray(dims, name);}
    void GetArray(std::vector<int> &dims, const std::string &name, double *&xp)
                { xp = GetDoubleArray(dims, name);}

    void SetBuffer(const char *buffer);

protected:
    const char *buffer;
    int currentPos;
};

#endif // !defined BINARYREADER_H
