// BinaryWriter.h: interface for the BinaryWriter class.
//
//////////////////////////////////////////////////////////////////////

#ifndef BINARYWRITER_H
#define BINARYWRITER_H

#include "DigitalMaterial.h"
#include "DMWriter.h"

class BinaryWriter : public DMWriter  
{
public:
    BinaryWriter();
    virtual ~BinaryWriter();
    //! Not used
    void Open() {}
    //! Not used
    void Close() {}
    //! Resets \a currentSize to 0
    void EmptyBuffer() {this->currentSize = 0;}
    const char *GetBuffer() const {return buffer;}
    void Put(const Serializable *serializable, const std::string &name="root");
    virtual void PutBool( bool b, const std::string& name );
    virtual void PutInt(int n, const std::string &name);
    virtual void PutDouble(double x, const std::string &name);
    virtual void PutString(const std::string &str, const std::string &name);
    virtual void PutIntArray(const int *data, const std::vector<int> &dims, const std::string &name);
    virtual void PutDoubleArray(const double *data, const std::vector<int> &dims, const std::string &name);

protected:
    void Allocate(int newSize);
    char *buffer;
    int currentSize;
    int bufferSize;


};

#endif // !defined BINARYWRITER_H
