%{
#include <string>
#include "DMException.h"
#include "NetCDFError.h"
#include "NotEnoughMemory.h"
#include "IndexError.h"
%}

%exception {
	try {
		$action
	} catch (NetCDFError n) {
		const std::string& msg = n.GetString();
		PyErr_SetString(PyExc_IOError, msg.c_str());
		return NULL;
	} catch (NotEnoughMemory m) {
		const std::string& msg = m.GetString();
		PyErr_SetString(PyExc_MemoryError, msg.c_str());
		return NULL;
	} catch (IndexError i) {
		const std::string& msg = i.GetString();
		PyErr_SetString(PyExc_IndexError, msg.c_str());
		return NULL;
	} catch (AttributeError a) {
		const std::string& msg = a.GetString();
		PyErr_SetString(PyExc_AttributeError, msg.c_str());
		return NULL;
	} catch (DMException e) {
		const std::string& msg = e.GetString();
		PyErr_SetString(PyExc_RuntimeError, msg.c_str());
		return NULL;
	}
}
