/*! \file DMLastHeader.h
	\brief This should be the last header file included after user header files.

	This header file maps new() to a debug version of new().  There isn't
	an automatic way to replace the library on Win32.
	*/

#ifdef _MSC_VER

#ifdef _DEBUG
// This macro maps new to the version in crtdbg.h, a standard windows
// debug header file.
// The confusion in these definitions is caused by our use
// of new (std::nothrow).  We can match only one of the two possible
// uses of new a) new() or b) new(std::nothrow) so I chose to match
// the more portable nothrow version.
//#define new(s) ::operator new(s, _NORMAL_BLOCK, __FILE__, __LINE__)
//#define new(s) ::operator new(_NORMAL_BLOCK, __FILE__, __LINE__)
#define new(s) new( _NORMAL_BLOCK, __FILE__, __LINE__)
//#define new new( _NORMAL_BLOCK, __FILE__, __LINE__)

#endif //_DEBUG

#endif
