#ifndef _IEEEFLOATINGPOINT_H_
#define _IEEEFLOATINGPOINT_H_

/**
 * \file IEEEFloatingPoint.h
 *
 * There is an ANSI/IEEE 754 Floating Point Standard which specifies
 * ways to get information on machine precision and a bunch of other
 * numerics devices.  Until we start using it heavily, we can make
 * sure our calls to related functions match the standard and provide
 * machine-dependent implementations here.
 * \author Drew Dolgert
 * \date 12 Feb 2000
 */

#ifdef _MSC_VER

#include "float.h"
/*! On Windows, finite is defined in _finite.  The leading
	underscore indicates this is known to be a machine-dependent
	function and we should wrap it in a standard version, so don't
	call _finite from the body of the code.
	*/
int finite(double val);

#else // _MSC_VER

#include <math.h>

#endif

#endif // _IEEEFLOATINGPOINT_H_
