// Minimizer.h: interface for the Minimizer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MINIMIZER_H
#define MINIMIZER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

#include "Minimizable.h"

//! Minimizes functions of many variables. Calling function provides space for the variables (parameters) and an object of type Minimizable which has functions which return ObjectiveFunction, Gradient, etc.


/**
 *
 * \author nbailey 
 * \date 6/11/2000
 * \ingroup moleculardynamics
 */

class Minimizer  
{
public:
	Minimizer();
	virtual ~Minimizer();
	virtual double Minimize(double *parameters,Minimizable *minimizable)=0;
	
protected:
	int nParameters;
	
};


#endif // !defined(MINIMIZER_H)
