### COMMUNICATION ###

%{
#include "Parallel/MPIProtocol.h"
#include "Parallel/MPISendBuffer.h"
#include "Parallel/MPIRecvBuffer.h"
%}

class MPISendBuffer: public DMWriter
{
public:
	%extend
	{
		void PutNumPyArrayInt(PyObject *obj)
		{
			ASSERT(PyArray_Check(obj)) ;
			PyArrayObject *o = (PyArrayObject *)(obj);
			std::vector<int> vect(o->dimensions, o->dimensions+o->nd);
			const int *data = (const int*)(o->data);
			self->PutIntArray(data, vect, "");
		}
	}
};

class MPIRecvBuffer: public DMReader 
{
public:
	%extend
	{
		PyObject* GetNumPyArrayInt()
		{
			std::vector<int> vect;
			int *tmp = self->GetIntArray(vect, "");
			int totSize = 1;
			for(int c=0; c<vect.size(); ++c) totSize *= vect[c];
			PyObject *o = PyArray_FromDims(vect.size(), &vect[0], 'i');
			memcpy(((PyArrayObject *)o)->data, tmp, sizeof(int)*totSize);
			delete [] tmp;
			return o;
		}
	}
}; 

class MPIProtocol : public DMProtocol
{
public:
	MPIProtocol();
};

