#ifndef _SERIAL_BUILDER_H_
#define _SERIAL_BUILDER_H_

#include "DigitalMaterial.h"
#include "SerialCreator.h"

//! This is a quick way to make a class which can build a type.
/*! An example of the use:	
	\begincode
	static SerialBuilder<ListOfAtoms> *_PLOAcreator = new SerialBuilder<ListOfAtoms>("ListOfAtoms");
	\endcode
	*/
template<class Type>
class SerialBuilder : public SerialCreator
{
public:
	//! Constructor.
	/*! You have to pass the type in the constructor.
		*/
	SerialBuilder(const std::string type): SerialCreator(type) {}
	//! Return an instance of the class.
	/*! This is called by the Serializable class. */
	Serializable* Build() const { return new Type();}
};

#endif //_SERIAL_BUILDER_H_
