#include "DigitalMaterial.h"

#include "SerialCreator.h"

#include "SerialFactory.h"

#include "DMLastHeader.h"

/**
  * This constructor registers the SerialCreator with the 
  * Singleton SerialFactory.
  */

SerialCreator::SerialCreator(const std::string type)
{
	this->type = type;
	SerialFactory::Instance()->Register( this );
}

const std::string& SerialCreator::GetType() const
{
	return this->type;
}
