#ifndef _SERIALCREATOR_H_
#define _SERIALCREATOR_H_

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"

class Serializable;

//! Abstract base class for classes which can build serialized objects.
/**
 * This class is responsible for building an object and registering its type..
 * The creator registers the type with the Singleton collaborating class,
 * SerialFactory.
 * SerialCreator is an abstract class.
 *
 * \author ajd27
 * \date 27 July 2000
 * \ingroup dmsystem
 * \sa ListOfAtomsBuilder
 **/

class SerialCreator
{
private:
	std::string type;
public:
	//! Constructor.
	SerialCreator(const std::string type) ; 
	//! Abstract method to create the object.
	virtual Serializable* Build() const = 0;
	//! Called by SerialFactory during registration.
	const std::string& GetType() const;
};


#endif // _SERIALCREATOR_H_
