/*	SerialTest application

	This application tests serializer readers and writers.

	author - Drew Dolgert
	date - 25 Feb 2001
	*/

#include <iostream>
#include "DynSer.h"
#include "NetCDFWriter.h"
#include "NetCDFReader.h"
#include "ASCIIReader.h"
#include "ASCIIWriter.h"
#include "DMException.h"
#include "DMLastHeader.h"

using namespace std;

//typedef ASCIIReader TheReader;
//typedef ASCIIWriter TheWriter;

typedef NetCDFReader TheReader;
typedef NetCDFWriter TheWriter;

int main( int argc, char* argv[] )
{
	bool bPassed = true;
	try {
		int iSeed;
		for ( iSeed = 0; iSeed < 20; iSeed++ ) {
			DynSerA t0( iSeed );
			
			{
				TheWriter writer( "test.dat" );
				writer.Put( &t0 );
			}
			
			TheReader reader( "test.dat" );
			Serializable* s1 = reader.Get();
			DynSerA* t1 = dynamic_cast<DynSerA*>( s1 );
			
			if ( t1->IsEqual( t0 ) ) {
				cout << "They are equal." << endl;
			} else {
				cout << "They are not equal." << endl;
				bPassed = false;
			}

			delete t1;
		}
	} catch ( DMException& e ) {
		bPassed = false;
		cout << e;
	}

	if ( bPassed ) {
		cout << "Passed test." << endl;
	} else {
		cout << "Failed test." << endl;
	}

	return 0;
}