// Serializable.h: interface for the Serializable class.
//
//////////////////////////////////////////////////////////////////////

#ifndef SERIALIZABLE_H
#define SERIALIZABLE_H

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"

class DMWriter;
class DMReader;

//! Abstract base class for classes which Writer and Reader can serialize.
class Serializable  
{
public:
	//! Save the class.
	virtual void Save(DMWriter *writer) const = 0;
	//! Load the class.
	virtual void Load(DMReader *reader) = 0;
	//! Get the string name of the class for saving or loading.
	virtual const std::string &GetType() const = 0;
};

#endif // !defined(SERIALIZABLE_H)
