#ifndef _STREAM_READER_H_
#define _STREAM_READER_H_

#include "DMFirstHeader.h"
#include <string>
#include <istream>
#include "DigitalMaterial.h"
#include "DMReader.h"

class StreamReader: public DMReader
{
	std::istream* m_pIn;
	std::string m_offset;
	static const int BUFSIZE;
	char m_buffer[];
public:
	StreamReader( );
	virtual ~StreamReader( );
	void Open();
	void Close();
	std::string GetType(const std::string &name="root"); 
	bool Fill(Serializable *toFill, const std::string &name="root");
	Serializable *Get(const std::string &name="root");
	bool GetBool( const std::string& name );
	int GetInt(const std::string &name);
	double GetDouble(const std::string &name);
	std::string GetString(const std::string &name);
	void GetDimensions( std::vector<int>& dims, const std::string& name );
	int *GetIntArray(std::vector<int> &dims, const std::string &name);
	double *GetDoubleArray(std::vector<int> &dims, const std::string &name);
private:
	void Done();
};

#endif // _STREAM_READER_H_