#ifndef _TrivialRWLOCK_H_
#define _TrivialRWLOCK_H_

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "RWLockImp.h"

//! Read-write lock which does nothing.
/**
 * This is the Trivial implementation of read-write locks.
 * See RWLock for details on use.
 * \author Drew Dolgert
 * \date March 2000
 * \ingroup dmsystem
 */
class TrivialRWLock : public RWLockImp
{
public:
	virtual bool InitializeLock() { return true; }
	virtual void CleanupLock() {}
	virtual void ReadLock() {}
	virtual void WriteLock() {}
	virtual void ReadRelease() {}
	virtual void WriteRelease() {}
};

#endif // _TrivialRWLOCK_H_