#ifndef _TRIVIALTHREAD_
#define _TRIVIALTHREAD_ 1

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "Threadable.h" // includes Runnable
#include "ThreadImp.h"

//! The Trivial implementation of a Thread.
/**
 * It always return SUCCESS.  It doesn't keep track of any inner logic as though there
 * were a thread.
 * \author ajd27
 * \date 28 July 2000
 * \ingroup dmsystem
 */
class TrivialThread : public ThreadImp
{
	Threadable* threadable;
	Runnable* runnable;
public:
	TrivialThread() : threadable(0), runnable(0) {};
	virtual void SetTask(Runnable *thread) { this->runnable = thread; }
	virtual void SetTask(Threadable *thread) { this->threadable = thread; }
	virtual int Start() { return SUCCESS; }
	virtual int Stop() { return SUCCESS; }
	virtual int Pause() { return SUCCESS; }
	virtual int Resume() { return SUCCESS; }
	virtual int Toggle() { return SUCCESS; }
	// interface to simulation
	virtual bool IsRunning() { return true; }
	virtual ~TrivialThread() {}
};


#endif // _TRIVIALTHREAD_
