// blas.h header file for the blas declarations
//
////////////////////////////////////////////////


extern "C"

{
	// BLAS routines 

	void cblas_dscal(const int n, const double scaleFactor, const double *positions,
		const int incPositions);

	double cblas_dnrm2(const int n, const double *source, const int inc);

	void cblas_dcopy(	const int n, const double *source, 
										const int incsrc, double* dest,
										const int incdest);
	void cblas_daxpy(	const int n, const double scaleFactor,
										const double *shift, const int incShift,
										double *dest, const int incdest);
	int cblas_idamax(	const int n, const double *positions, const int incPositions);

	double cblas_dnrm2(const int N,const double *X,const int incX);

	double cblas_ddot(const int N, const double *X, const int incX, const double *Y, const int incY);
}
