// AtomsInitializer.h: interface for the AtomsInitializer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ATOMSINITIALIZER_H
#define ATOMSINITIALIZER_H


#include "DMFirstHeader.h"


class ListOfAtoms;

//! Abstract base class for classes which create atoms in certain configurations.
/*!	Abstract class Create needed by any AtomsInitializer.
	Under normal circumstances, all ListOfAtomses will be generated 
	by AtomsInitializers; see comments under ListOfAtoms.
	*/

class AtomsInitializer
{
public:
	//! This step actually creates the classes while others set up the cretaion.
	virtual void Create(ListOfAtoms *atoms)=0;
	//! Rough center (for graphics)
	virtual const double *GetCenter() const = 0;
	//! Rough size (for graphics)
	virtual double GetMaxSize() const = 0;	
};

#endif // !defined(ATOMSINITIALIZER_H)
