// SphericalClusterInitializer.h: interface for the SphericalClusterInitializer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef SPHERICALCLUSTERINITIALIZER_H
#define SPHERICALCLUSTERINITIALIZER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

// Implementation of the ClusterInitializer factory method
// Will generate a circular or spherical cluster of atoms, depending on dimension
// One should set the radius and perhaps the center of the cluster before Create()

#include "ClusterInitializer.h"

class SphericalClusterInitializer : public ClusterInitializer
{
public:
  SphericalClusterInitializer(double radius, BravaisLatticeWithBasis *bravais);
  virtual ~SphericalClusterInitializer();
  void SetRadius(double radius); 
  double GetRadius() const {return radius;}
  

protected:
	double radius;
	int SetMaxSize();
	bool Inside(double X[DIMENSION]);
};

#endif // !defined(SPHERICALCLUSTERINITIALIZER_H)
