// BoundaryConditions.h: interface for the BoundaryConditions class.
//
//////////////////////////////////////////////////////////////////////

#ifndef BOUNDARYCONDITIONS_H
#define BOUNDARYCONDITIONS_H


// Nick Bailey
// I haven't figured out who should own this class/have pointers to it. NeighborLocator
// should at least have a pointer to it. Force calculators also need to be able to access it

// Default is free boundary conditions

#include <iostream>
#include "DigitalMaterial.h"
#include "Cloneable.h"
#include "Serializable.h"

template<class Type, int N> class DMArray;

class BoundaryConditions  : public Cloneable, public Serializable
{
public:
	BoundaryConditions(){ }
	virtual ~BoundaryConditions(){ /* cout << "BoundaryConditions deleted" << endl; */ }
	virtual void EnforceBoundaryConditions(DMArray<double, DIMENSION> *positions) const=0;
	virtual void EnforceBoundaryConditions(double *position) const=0; // Can we have (*)[DIMENSION] ?
	virtual void DifferenceBoundaryConditions(DMArray<double, DIMENSION> *displacements) const=0;
	virtual void DifferenceBoundaryConditions(double (*displacements)[DIMENSION],int nAtoms) const=0;
	virtual BoundaryConditions *Copy() const=0;
};

#endif // !defined(BOUNDARYCONDITIONS_H)
