// AndersonDynamics.cpp: implementation of the AndersonDynamics class.
//
//////////////////////////////////////////////////////////////////////

#include "DigitalMaterial.h"

#include "AndersonDynamics.h"
#include "DMArray.h"

#include "DMLastHeader.h"

const std::string AndersenDynamics::className = std::string("AndersenDynamics");

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


AndersenDynamics::AndersenDynamics(double frequencyDt, double sigma, int seed) : 
	rand(seed), sigma(sigma), frequencyDt(frequencyDt)
{
}

void AndersenDynamics::AdjustVelocities(DMArray<double, DIMENSION> *velocities)
{
	DMArrayIterator<double, DIMENSION> veloIter(velocities);
	int coord;
	for(veloIter.Init(); !veloIter.IsDone(); veloIter.Next())
	{
		for(coord=0; coord<DIMENSION; ++coord)
			if(rand.uniform() < frequencyDt) veloIter.Current()[coord] = rand.gaussian(sigma);
	}
}
