// UniformlyMovingBody.h: interface for the UniformlyMovingBody class.
//
//////////////////////////////////////////////////////////////////////

#ifndef UNIFORMLYMOVINGBODY_H
#define UNIFORMLYMOVINGBODY_H

#include "DigitalMaterial.h"
#include "Constraint.h"


class UniformlyMovingBody: public Constraint
{
public:
	UniformlyMovingBody(const double velocity[DIMENSION]);
	~UniformlyMovingBody() {}
	Constraint *Copy() const;
	
	void SetVelocity(const double velocity[DIMENSION]);
	void AdjustVelocities(DMArray<double, DIMENSION> *velocities);


	int NumberGeneralizedCoordinates();
	void SetGeneralizedCoordinates(double *generalizedCoordinates) ;
    void GetGeneralizedCoordinates(double *generalizedCoordinates); 
	void IncrementGeneralizedCoordinate(int n,double inc);
#ifndef SWIG
    void CalculateGeneralizedForces(DMArray<double, DIMENSION> *forces, double *generalizedForces);
    void DerivativesWRTGeneralizedCoordinates(int atom, double (*gradient)[DIMENSION]);

#endif // SWIG
	const std::string &GetType() const
	{
		return className;
	}

private:
	double velocity[DIMENSION];
	static const std::string className;
};


#endif // !defined(UNIFORMLYMOVINGBODY_H)
