// UniformlyMovingCenterOfMass.h: interface for the UniformlyMovingCenterOfMass class.
//
//////////////////////////////////////////////////////////////////////

#ifndef UNIFORMLYMOVINGCENTEROFMASS_H
#define UNIFORMLYMOVINGCENTEROFMASS_H

#include "DigitalMaterial.h"
#include "Constraint.h"

class UniformlyMovingCenterOfMass: public Constraint
{
public:
	UniformlyMovingCenterOfMass(const double velocity[DIMENSION]);
	void AdjustVelocities(DMArray<double, DIMENSION> *velocities);
	void SetVelocity(const double velocity[DIMENSION]);

	// GeneralizedCoordinate functions: most throw errors right now (March 01)
	int NumberGeneralizedCoordinates();
	void SetGeneralizedCoordinates(double *generalizedCoordinates) ;
    void GetGeneralizedCoordinates(double *generalizedCoordinates); 
	void IncrementGeneralizedCoordinate(int n,double inc);
#ifndef SWIG
    void CalculateGeneralizedForces(DMArray<double, DIMENSION> *forces, double *generalizedForces);
    void DerivativesWRTGeneralizedCoordinates(int atom, double (*gradient)[DIMENSION]);
#endif // SWIG

	const std::string &GetType() const
	{
		return className;
	}


private:
	double velocity[DIMENSION];
	static const std::string className;
};

#endif // !defined(UNIFORMLYMOVINGCENTEROFMASS_H)
