template<>
inline void DMArray<double, DIMENSION>::Sum(double sum[DIMENSION])const
{
	memset(sum, 0, DIMENSION*sizeof(double));
	int size = cache.sizes.size();
	for(int i=0; i<size; ++i) 
	{
		int length = cache.sizes[i];
		double (*ptr)[DIMENSION] = cache.ptrs[i];
		for(int j=0; j<length; ++j)
			for(int coord=0; coord<DIMENSION; coord++)
				sum[coord] += ptr[j][coord];
	}
#ifdef DMPARALLEL
	double partialSum[DIMENSION];
	memcpy(partialSum, sum, DIMENSION*sizeof(double));
    dmProtocol->AllReduce(partialSum, sum, DIMENSION, DMProtocol::SUM);
#endif
}

template<>
inline void DMArray<double, DIMENSION>::Average(double avg[DIMENSION]) const
{
	double sum[DIMENSION+1];
	memset(sum, 0, DIMENSION*sizeof(double));
	int size = cache.sizes.size();
	for(int i=0; i<size; ++i) 
	{
		int length = cache.sizes[i];
		double (*ptr)[DIMENSION] = cache.ptrs[i];
		for(int j=0; j<length; ++j)
			for(int coord=0; coord<DIMENSION; coord++)
				sum[coord] += ptr[j][coord];
	}
	sum[DIMENSION] = (double) Size();
#ifdef DMPARALLEL
	double partialSum[DIMENSION+1];
	memcpy(partialSum, sum, (1+DIMENSION)*sizeof(double));
    dmProtocol->AllReduce(partialSum, sum, DIMENSION+1, DMProtocol::SUM);
#endif
	for(int coord=0; coord<DIMENSION; ++coord)
		avg[coord] = sum[coord] / sum[DIMENSION];
}

