#include "DMFirstHeader.h"

#include "DigitalMaterial.h"
#include "DomainSubdivision.h"
#include "DMException.h"
#include "SprintString.h"
#include "DMArray.h"
#include "DMLastHeader.h"

using namespace std;

DomainSubdivision::DomainSubdivision(const int cpuLayout[DIMENSION],
													 int myDomain)
{
	int coord;
	for(coord = 0; coord<DIMENSION; ++coord) 
		this->cpuLayout[coord] = cpuLayout[coord];

	this->myDomain = myDomain;

	this->numberOfProcs = 1;
	for(coord=0; coord<DIMENSION; ++coord)
	{
		this->numberOfProcs *= cpuLayout[coord];
		if(cpuLayout[coord] == 0) throw DMException("HomogeneousDomainSubdivision",
			"Constructor", 
			SprintString("with 0 processors along direction %i, you'll run into trouble...",
			coord));
	}

}