// ParallelAtomsInitializer.h: interface for the ParallelAtomsInitializer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PARALLELATOMSINITIALIZER_H
#define PARALLELATOMSINITIALIZER_H

#include "DigitalMaterial.h"

#include "AtomsInitializer.h"

class ParallelAtomsInitializer : public AtomsInitializer  
{
public:
    ParallelAtomsInitializer(AtomsInitializer *initializer);
    virtual ~ParallelAtomsInitializer() {}

    //! This step actually creates the classes while others set up the cretaion.
    void Create(ListOfAtoms *atoms);

    //! Rough center (for graphics)
    const double *GetCenter() const {return initializer->GetCenter();}

    //! Rough size (for graphics)
    double GetMaxSize() const {return initializer->GetMaxSize();}

private:
    AtomsInitializer *initializer;
};

#endif // !defined(AFX_PARALLELATOMSINITIALIZER_H__BEDCC431_0AE2_45E6_9779_80767C927109__INCLUDED_)
