/// DOMAIN SUBDIVISION ///
%{
#include "DomainSubdivision.h"
#include "HomogeneousDomainSubdivision.h"
%};

%include "HomogeneousDomainSubdivision.h"
class HomogeneousDomainSubdivision {};


/// SYNCHRONZER ///
%{
#include "Synchronizer.h"
%};

class Synchronizer
{
public:
	Synchronizer(ArrayDoubleVector *positions=0, 
				 DMProtocol *protocol = dmProtocol);
	virtual ~Synchronizer();
	void SetPositionsArray(ArrayDoubleVector *positions);
    void Rebuild(const DomainSubdivision *domain);
	void Synchronize(ArrayDoubleVector *positions);
};


/// MIGRATOR ///
%{
#include "Migrator.h"
%};

class Migrator
{
public:
	Migrator(DomainSubdivision *domain,
			 ArrayDoubleVector *positions = 0, 
			 DMProtocol *protocol = dmProtocol);
	void SetPositionsArray(ArrayDoubleVector *positions);
	void Migrate(void);
};

/// PARALLEL NEIGHBORLOCATOR ///


%{
#include "ParallelNeighborLocator.h"
%};

class ParallelNeighborLocator : public NeighborLocator
{
public:
    ParallelNeighborLocator(Migrator *m, NeighborLocator *neighborLocator); 
};


/// PARALLEL POTENTIAL ///
%{
#include "ParallelPotential.h"
%};

%include "ParallelPotential.h"


/// PARALLEL ATOMSINITIALIZER ///
%{
#include "ParallelAtomsInitializer.h"
%};

class ParallelAtomsInitializer: public AtomsInitializer
{
public:
    ParallelAtomsInitializer(AtomsInitializer *initializer);
};
