// CompositePotential.h: interface for the CompositePotential class.
//
//////////////////////////////////////////////////////////////////////

#ifndef COMPOSITEPOTENTIAL_H
#define COMPOSITEPOTENTIAL_H

#include "DMFirstHeader.h"

#include "DigitalMaterial.h"
#include "Potential.h"

class CompositePotential : public Potential
{
public:
	CompositePotential() {potential1=0; potential2=0;};
	CompositePotential(Potential *potential1, Potential *potential2);
	~CompositePotential();

	void CalculateForces(ListOfAtoms *atoms, DMArray<double, DIMENSION> *forces);
	double CalculateEnergy(ListOfAtoms *atoms);

	double GetLengthScale() const; // this is arbitrary !!!
	double GetEnergyCurvatureScale() const ;// Arbitrary! Should be zero.
	double CalculateAtomicEnergy(ListOfAtoms *atoms, int i);
//	double GetInnerCutoffDistance() const;
	
	void Save(DMWriter *writer) const;
	void Load(DMReader *reader);

	void Allocate(const DMArray<double, DIMENSION> *array);

	//! Get the string name of the class for saving or loading.
	const std::string &GetType() const
	{
		return className;
	}

#ifndef SWIG
private:
	Potential *potential1;
	Potential *potential2;
 	DMArray<double, DIMENSION> *forces2;

	static const std::string className;
#endif // SWIG 
};

#endif // !defined(COMPOSITEPOTENTIAL_H
