// AtomsLocator.h: interface for the AtomsLocator class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ATOMSLOCATOR_H
#define ATOMSLOCATOR_H

#include "DMFirstHeader.h"
#include "DigitalMaterial.h"
#include <vector>
class ListOfAtoms;

/*!

  \author nbailey
  \date 7/11/2001
  \ingroup moleculardynamics

 */


class AtomsLocator
{
public:
	virtual const std::vector<int> &GetAtomNumbers(ListOfAtoms *atoms);
	virtual bool Inside(const double *position)=0;

protected:
	std::vector<int> listOfAtomNumbers;

};

#endif // !defined(ATOMSLOCATOR_H)
