// IsotropicMultipoleField.h: interface for the IsotropicMultipoleField class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ISOTROPICMULTIPOLEFIELD_H
#define ISOTROPICMULTIPOLEFIELD_H

#include "DMFirstHeader.h"
#include <math.h>
#include "DigitalMaterial.h"
#include <assert.h>
#include <complex>

#include "MultipoleField.h"


class IsotropicMultipoleField : public MultipoleField
{
public:
	IsotropicMultipoleField(int maximumOrder, const double direction[DIMENSION], double center[DIMENSION],double nu);
	virtual ~IsotropicMultipoleField();
	
	
	void ElasticDisplacement(const double position[DIMENSION], double displacement[DIMENSION]);
	void GradientWRTPosition(const double position[DIMENSION],  double gradientWRTPosition[DIMENSION][DIMENSION]);
#ifndef SWIG
	void GradientWRTParameters(const double position[DIMENSION], double (*displacementGradient)[DIMENSION]);

private:
	double nu;
	double nu_factor;
#endif //SWIG
};

#endif // !defined(ISOTROPICMULTIPOLEFIELD_H)
