// NotchMaker.h: interface for the NotchMaker class.
//
//////////////////////////////////////////////////////////////////////

#ifndef NOTCHMAKER_H
#define NOTCHMAKER_H

#include "DMFirstHeader.h"
#include <math.h>
#include "DigitalMaterial.h"

#include "VoidMaker.h"

class NotchMaker : public VoidMaker  // There is no difference between 2D and 3D because
// everything is supposed not to depend on the 3rd dimension (the planes of the notch are // to the 3rd dim) 
{
public:
	NotchMaker(double openingAngle, double tipLocation[DIMENSION], double dirAngle = 0.);
	virtual ~NotchMaker();

	void SetOpeningAngle(double openingAngle);
	double GetOpeningAngle() const;

	void SetTipLocation(const double tipLocation[DIMENSION]);
	const double *GetTipLocation() const {return (const double *) tipLocation; }

	void SetDirAngle(double dirAngle);
	double GetDirAngle() const;

private:
	bool Inside(const double X[DIMENSION]);
	double tipLocation[DIMENSION];
	double normal1[DIMENSION];
	double normal2[DIMENSION];
	void UpdateMemberVariables();
	double dirAngle;
	double openingAngle;
};

#endif // !defined(NOTCHMAKER_H)
