%{
#include "CopySubset.h"
#include "IncrementalMinimizer.h"
#include "NotchMaker.h"
#include "WedgeMaker.h"
#include "OverlapPruner.h"
#include "SliceAtomsLocator.h"
#include "SphereAtomsLocator.h"
#include "RectangleAtomsLocator.h"
#include "Translator.h"
#include "UndercoordinatedPruner.h"
%}

%include "CopySubset.h"

%nodefault Transformer;
class Transformer
{
public:
	void Transform(ListOfAtoms *atoms);
};

%include "OverlapPruner.h"

%nodefault VoidMaker;
class VoidMaker : public Transformer{};

%include "NotchMaker.h"
%include "WedgeMaker.h"
%include "UndercoordinatedPruner.h"

/* Note: IncrementalMinimizer calls the Lapack function dgelsd which isn't included in all Lapack versions (it's relatively new)*/
%include "IncrementalMinimizer.h"
%nodefault AtomsLocator;
class AtomsLocator {};
%include "RectangleAtomsLocator.h"
%include "SliceAtomsLocator.h"
%include "SphereAtomsLocator.h"

%include "Translator.h"

/* ElasticField Transformers are in a separate file because there are many of them*/
%include "ElasticFieldTransformers.i"
