// Translator.h: interface for the Translator class.
//
//////////////////////////////////////////////////////////////////////

#ifndef TRANSLATOR_H
#define TRANSLATOR_H

#include "DMFirstHeader.h"
#include <math.h>
#include "DigitalMaterial.h"
#include "Transformer.h"

//! This transformer will simply translate a ListOfAtoms by some global displacement vector called shift.


/**
 * This transformer will simply translate a ListOfAtoms by some global 
 * displacement vector called shift.
 *
 * \ingroup moleculardynamics
 * \author nbailey
 * \date May 16, 2000
 */


class Translator : public Transformer
{
public:
	Translator(double shift[DIMENSION]);
	virtual ~Translator();

	void SetShift(const double shift[DIMENSION]);
	const double *GetShift() const {return shift;}

	virtual void Transform(ListOfAtoms *atoms);
 private:
	double shift[DIMENSION];
};

#endif // !defined(TRANSLATOR_H)
