// WedgeMaker.h: interface for the WedgeMaker class.
//
//////////////////////////////////////////////////////////////////////

#ifndef WEDGEMAKER_H
#define WEDGEMAKER_H

#include "DMFirstHeader.h"
#include <math.h>
#include "DigitalMaterial.h"

#include "VoidMaker.h"

class WedgeMaker : public VoidMaker  

{
public:
	WedgeMaker(double direction[DIMENSION], double center[DIMENSION], double normal1[DIMENSION], double normal2[DIMENSION]);
	virtual ~WedgeMaker();


	void SetDirection(const double direction[DIMENSION]);
	const double *GetDirection() const {return (const double *) direction; };

	void SetCenter(const double center[DIMENSION]);
	const double *GetCenter() const {return (const double *) center; };

	void SetNormal1(const double normal1[DIMENSION]);
	const double *GetNormal1() const {return (const double *) normal1; };

	void SetNormal2(const double normal2[DIMENSION]);
	const double *GetNormal2() const {return (const double *) normal2; };

private:
	bool Inside(const double X[DIMENSION]);
	double direction[DIMENSION];
	double center[DIMENSION];
	double normal1[DIMENSION];
	double normal2[DIMENSION];

};

#endif // !defined(WEDGEMAKER_H)
