// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "MD.h"
#include "MDDoc.h"

#include "ChildFrm.h"
#include <string>

#include "ChangeParameterMenu.h"
#include "TransformerMenu.h"
#include "MDComponentSelector.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_MDIACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}

void CChildFrame::DeleteNamedMenu(CMenu *pMenu, std::string& sName)
{
	int nItems = pMenu->GetMenuItemCount();
	int i;
	CString str;
	for (i=nItems-1; i>=0; i--) {
		if (pMenu->GetMenuString(i,str,MF_BYPOSITION) &&
			(strcmp(str,sName.c_str()) == 0)) {
			int success = pMenu->RemoveMenu(i,MF_BYPOSITION);
			 // will tell you if it succeeds
			return;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

void CChildFrame::OnMDIActivate(BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd)
{
	// call the base class to let standard processing switch to
	// the top-level menu associated with this window
	CMDIChildWnd::OnMDIActivate(bActivate, pActivateWnd, pDeactivateWnd);

	// ajd27 - The following line won't work in an MDI application.
	// CMenu * pmenuMain = GetParent()->GetMenu();
	// Following is the way to get a pointer to the actual menubar.
	// http://msdn.microsoft.com/library/backgrnd/html/msdn_mfcfaq50.htm
	// do our modifications, if we are being activated

	// You can have several different instances of CChildFrame each with its
	// own document, but they share the same menu resource.  We need
	// to make sure that a) We have a select menut and b) our select
	// menu goes with our document.
	if (bActivate) {
		CMenu *pmenuMain = AfxGetMainWnd()->GetMenu();
		CMDDoc *pDoc = (CMDDoc *)this->GetActiveDocument();
		DeleteNamedMenu(pmenuMain,std::string("Change Parameters"));
		pmenuMain->InsertMenu(3,MF_BYPOSITION|MF_POPUP,
			(UINT) pDoc->GetChangeParameterMenu()->GetMenu(),
			_T("Change Parameters"));
		DeleteNamedMenu(pmenuMain,std::string("Transformers and Movers"));
		pmenuMain->InsertMenu(5,MF_BYPOSITION|MF_POPUP,
			(UINT) pDoc->GetTransformerMenu()->GetMenu(),
			_T("Transformers and Movers"));
		DeleteNamedMenu(pmenuMain, std::string("Select"));
		pmenuMain->InsertMenu(6,MF_POPUP|MF_BYPOSITION,
			(UINT) pDoc->GetComponentSelector()->GetMenu(),
			_T("Select"));
		pmenuMain->Detach(); // XXX Don't think I need to do this for a pointer.
	}
}
