// MDDoc.h : interface of the CMDDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_)
#define AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MDSimulation.h"	// Added by ClassView

// All of these are referenced in the interface only as pointers.
// We declare them here without specification in order to minimize
// the tendency to rebuild the simulation.
class DialogBuilder;
//class vtkPropSource;
class MDComponentSelector;
class ChangeParameterMenu;
class TransformerMenu;
class MDThread;
class Thread;
/*! \ingroup windows */

class CMDDoc : public CDocument
{
protected: // create from serialization only
	CMDDoc();
	DECLARE_DYNCREATE(CMDDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

	// Digital Material: The wizard won't let us add these?
	virtual void OnMenuSelect(UINT nID);
	virtual void OnUpdateComponentUI (CCmdUI* pCmdUI);

// Implementation
public:
	MDSimulation sim;
	Thread *const GetSimThread();
	MDComponentSelector *const GetComponentSelector();
	ChangeParameterMenu *const GetChangeParameterMenu();
	TransformerMenu *const GetTransformerMenu();
//	vtkPropSource* GetVTKPropSource(void);

	virtual ~CMDDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
private:
	MDThread *simBody;
	Thread *simThread;
//	vtkPropSource *vtkCoordSource;
	MDComponentSelector *componentSelector;
	ChangeParameterMenu *changeParameterMenu;
	TransformerMenu *transformerMenu;

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMDDoc)
	afx_msg void OnControlPauseresume();
	//}}AFX_MSG
//	afx_msg LRESULT OnUpdateViews( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_)
