#ifndef _COMMANDIDMANAGER_H_
#define _COMMANDIDMANAGER_H_

#include "IDResourceManager.h"

/**
 * This class is responsible for giving clients a unique
 * integer ID out of a range of integer IDs.  It also reclaims
 * old IDs if the client is kind enough to release them.
 *
 * The implementation is in IDResourceManager.h.
 * \author Drew Dolgert
 * \date 19 Feb 2000
 * \ingroup windows
 */
class CommandIDManager
{
private:
	static CommandIDManager* _instance;
	IDResourceManager resourceManager;
public:
	static CommandIDManager *Instance() {
		if (_instance==0) _instance = new CommandIDManager();
		return _instance;
	}
	int GetCommandID() { return resourceManager.GetID(); }
	void ReleaseCommandID(int ID) { resourceManager.ReleaseID(ID); }
	virtual ~CommandIDManager() {}
protected:
	CommandIDManager() : resourceManager(0x9000,0x9FFF) { }
};


#endif // _COMMANDIDMANAGER_H_
