// DialogPacker.cpp: implementation of the DialogPacker class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MD.h"
#include "DialogPacker.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DialogPacker::DialogPacker()
{
	SetDlgTemplate(DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU,
								0,10,10,400,200);
	SetFontInfoA(8,"MS Sans Serif");
	SetCaption(_T("Dialog Packer Default Caption"));
}

DialogPacker::~DialogPacker()
{

}

void * DialogPacker::LockTemplate()
{
	int i = controlList.GetCount();

	WORD dialogWidth = wcslen(GetCaption()) * 4 + 30;	// Dialog-box coordinates = 4 per char
	WORD dialogHeight = 0;
	
	// controlList is a CObList of controls. We iterate over this list, packing the
	// controls vertically.
	if (!controlList.IsEmpty())
	{	
		CDlgTempl::CDlgItemTempl* control;
		for (POSITION pos = controlList.GetHeadPosition(); pos != NULL; )
		{
			control = (CDlgTempl::CDlgItemTempl*) controlList.GetNext(pos);
			// Positions overwritten			CPoint controlPosition = control->GetPosition();
			CSize controlSize = control->GetSize();
			
			control->SetPosition(0, dialogHeight);
			dialogHeight += (WORD) controlSize.cy;
			if (dialogWidth < controlSize.cx) dialogWidth = (WORD) controlSize.cx;
		}
	}

	// We now set the size of the box

	SetSize(dialogWidth, dialogHeight);

	// Change all controls to the same width

	if (!controlList.IsEmpty())
	{	
		CDlgTempl::CDlgItemTempl* control;
		for (POSITION pos = controlList.GetHeadPosition(); pos != NULL; )
		{
			control = (CDlgTempl::CDlgItemTempl*) controlList.GetNext(pos);
			// Positions overwritten			CPoint controlPosition = control->GetPosition();
			CSize controlSize = control->GetSize();
			
			control->SetSize(dialogWidth, (int) controlSize.cy);
		}
	}


	return CDlgTempl::LockTemplate();
}

void DialogPacker::SetSize(WORD cx, WORD cy)
{
	m_dlgTemplate.cx = cx;
	m_dlgTemplate.cy = cy;
}