// SimThreadController.h: interface for the SimThreadController class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_)
#define AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxmt.h>	// for locking

class SimThreadController  
{
public:
	void ResumePaused();
	bool ThreadRunning();
	void Started();
	void Stopped();
	void Stop();
	void Paused();
	void Resume();
	void Pause();
	SimThreadController();
	virtual ~SimThreadController();
	bool PauseNow() const;
	bool StopNow() const;

private:
	CEvent threadResume;
	CEvent threadPaused;
	volatile bool pauseThread;
	CEvent threadStopped;
	volatile bool stopThread;
};

#endif // !defined(AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_)
