// SampleView.cpp : implementation of the CSphereView class
//

#include "stdafx.h"
#include "SphereView.h"
#include "vtkPropSource.h"
#include "MDDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSphereView

IMPLEMENT_DYNCREATE(CSphereView, vtkMFCRenderView)

BEGIN_MESSAGE_MAP(CSphereView, vtkMFCRenderView)
	//{{AFX_MSG_MAP(CSphereView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER_UPDATE_SPHERE, OnUpdateSpheres)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSphereView construction/destruction

CSphereView::CSphereView()
{
	// TODO: add construction code here

}

CSphereView::~CSphereView()
{
}


/////////////////////////////////////////////////////////////////////////////
// CSphereView diagnostics

#ifdef _DEBUG
void CSphereView::AssertValid() const
{
	CView::AssertValid();
}

void CSphereView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMDDoc* CSphereView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDDoc)));
	return (CMDDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSphereView message handlers

void CSphereView::OnInitialUpdate() 
{
	CMDDoc *theDoc = (CMDDoc *)this->GetDocument();
	vtkPropSource* propSource = theDoc->GetVTKPropSource();

	CView::OnInitialUpdate();

	propSource->AddListener(this);
}

void CSphereView::SphereUpdate()
{
	::PostMessage(m_hWnd,WM_USER_UPDATE_SPHERE,1,0);
}

LRESULT CSphereView::OnUpdateSpheres(WPARAM wParam, LPARAM lParam)
{
	if(!::IsWindow(m_hWnd)) return 0;
//	MSG msg;
//	while (::PeekMessage(&msg,m_hWnd,WM_USER_UPDATE_SPHERE,
//				WM_USER_UPDATE_SPHERE, PM_REMOVE)) ;
	// When we call update, we give a hint=1, a note to ourselves that we
	// are the ones requesting the update so we know not to clear the window
	// before we draw.
	this->GetDocument()->UpdateAllViews(NULL,1);
	return 0; // Is this the right thing to return?
}




void CSphereView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint==1) {
		// TODO: Add your specialized code here and/or call the base class
		vtkPropCollection *propc;
		vtkProp *prop;
		// TODO: Add your specialized code here and/or call the base class
		// first remove any old actors
		this->Renderer->GetProps()->RemoveAllItems();
		CMDDoc *theDoc = (CMDDoc *)this->GetDocument();
		propc = theDoc->GetVTKPropSource()->GetProps();
		propc->InitTraversal();
		while (prop = propc->GetNextProp())
		{
			this->Renderer->AddProp(prop);
			this->Renderer->ResetCamera();
		}
		this->Invalidate(false); // Update without clearing screen
	}
	this->vtkMFCRenderView::OnUpdate(pSender, lHint, pHint);			
}
