// simThread.cpp

// Main loop: sets up and controls the simulation
// The software is designed so that this can be done in an interpreted, scripting language

#include "stdafx.h"
#include "MD.h"

#include "MDDoc.h"
#include "MDView.h"


UINT simThread( LPVOID pParam)
{
	// This is thread stuff: have to unpack everything from the "other side"
	// forced through the small hole of the pointer
	// Get pointer to view from other thread
	
	// Unpacking HWndStore
	
	HWndStore* phWndStore = (HWndStore *) pParam;
	
    if (phWndStore == NULL ||
	        !phWndStore->IsKindOf(RUNTIME_CLASS(HWndStore)))
		return 1;   // if pObject is not valid
		
	HWND hwnd = phWndStore->hwnd;
	CMDView *atomView = phWndStore->pcmdView;
	atomView->Detach();	// Detach former view
	atomView->Attach(hwnd);
	CMDDoc *pDoc = phWndStore->pcmdDoc;
	MDSimulation* sim = phWndStore->pSim;
	
	// Animation
	sim->GetListOfAtoms()->Attach(atomView);
	atomView->SetDiameter(sim->GetDiameter());    // returns the size of an atom
	atomView->SetPlottedRegionSize(sim->GetMaxSize());
	atomView->SetCenter(sim->GetAtomsInitializer()->GetCenter());

	// Create cluster
//	sim->GetAtomsInitializer()->Create(sim->GetListOfAtoms());	// Sets up cluster

/*	// XXX For class, should change these
//	atomView->SetPlottedRegionSize(3*sim->GetMaxSize());
//	atomView->SetCenter(sim->GetAtomsInitializer()->GetCenter());
	double plotCenter[2] = {0,0};
	atomView->SetCenter(plotCenter);
	atomView->SetPlottedRegionSize(40);

	// Change for class: old
	// Create cluster
// sim->GetAtomsInitializer()->Create(sim->GetListOfAtoms());	// Sets up cluster

// Thought for class
	PrimitiveListOfAtoms *atoms0 = (PrimitiveListOfAtoms *)sim->listOfListsOfAtoms.components[0];
	PrimitiveListOfAtoms *atoms1 = (PrimitiveListOfAtoms *)sim->listOfListsOfAtoms.components[1];
	RectangularClusterInitializer* rect = (RectangularClusterInitializer *)sim->listOfAtomsInitializers.components[0];
	SphericalClusterInitializer* sphere = (SphericalClusterInitializer *)sim->listOfAtomsInitializers.components[1];
	

	rect->Create(atoms0);	// Sets up surface

*/

	sim->GetListOfAtoms()->Notify();

	bool stopNow = false;
	while (!pDoc->simThreadController.StopNow())
	{
		sim->GetAtomsMover()->Move(sim->GetListOfAtoms());
		sim->GetListOfAtoms()->Notify();

		Sleep(0);	// Improves responsiveness

		if (pDoc->simThreadController.PauseNow())
			pDoc->simThreadController.Paused();	// Announce paused: wait for resume
	}
	
	pDoc->simThreadController.Stopped();
	return 1;
}
